"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function() {
        return PriorityQueue;
    }
});
var _lowerBoundJs = /*#__PURE__*/ _interopRequireDefault(require("./lower-bound.js"));
function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
function _defineProperties(target, props) {
    for(var i = 0; i < props.length; i++){
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}
function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var __classPrivateFieldGet = (void 0) && (void 0).__classPrivateFieldGet || function(receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _PriorityQueue_queue;
var PriorityQueue = /*#__PURE__*/ function() {
    "use strict";
    function PriorityQueue() {
        _classCallCheck(this, PriorityQueue);
        _PriorityQueue_queue.set(this, []);
    }
    _createClass(PriorityQueue, [
        {
            key: "enqueue",
            value: function enqueue(run, options) {
                options = _objectSpread({
                    priority: 0
                }, options);
                var element = {
                    priority: options.priority,
                    run: run
                };
                if (this.size && __classPrivateFieldGet(this, _PriorityQueue_queue, "f")[this.size - 1].priority >= options.priority) {
                    __classPrivateFieldGet(this, _PriorityQueue_queue, "f").push(element);
                    return;
                }
                var index = (0, _lowerBoundJs.default)(__classPrivateFieldGet(this, _PriorityQueue_queue, "f"), element, function(a, b) {
                    return b.priority - a.priority;
                });
                __classPrivateFieldGet(this, _PriorityQueue_queue, "f").splice(index, 0, element);
            }
        },
        {
            key: "dequeue",
            value: function dequeue() {
                var item = __classPrivateFieldGet(this, _PriorityQueue_queue, "f").shift();
                return item === null || item === void 0 ? void 0 : item.run;
            }
        },
        {
            key: "filter",
            value: function filter(options) {
                return __classPrivateFieldGet(this, _PriorityQueue_queue, "f").filter(function(element) {
                    return element.priority === options.priority;
                }).map(function(element) {
                    return element.run;
                });
            }
        },
        {
            key: "size",
            get: function get() {
                return __classPrivateFieldGet(this, _PriorityQueue_queue, "f").length;
            }
        }
    ]);
    return PriorityQueue;
}();
_PriorityQueue_queue = new WeakMap();
